/* Skeleton module.
 *
 * Skeleton module (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <modules/module.h>

/*************************************************************************/

namespace modules { class Core; }

/*************************************************************************/

/// Namespace for module skeleton.

/** The classes and extern functions and variables of each module must
  * be in a namespace of their own, to avoid name conflicts.
  *
  * The namespace name must be the same as the module name. */
	
namespace skeleton 
{

/*************************************************************************/

/// The module version.
static int const skeleton_version = 0x01050000;

/// The skeleton module class.

/** Each module declares a new class inherited from the Module class.
  * The Module::version() function must be overriden. Other
  * functions may be overriden too; see the documentation of the
  * Module class for more information. */

class Skeleton : public modules::Module
{
	public:
		/// Constructor.
		Skeleton(modules::Core &core);
		
		/// Implements Module::version().
		virtual int version() const { return skeleton_version; }
		
		/// Returns the core module.
		modules::Core &core() { return *m_core; }
	private:
		modules::Core *m_core;
};

/*************************************************************************/

} /* namespace skeleton */

/*************************************************************************/

#endif /* MODULE_H */
